package com.chuanxia.mcp.sched;

import cn.hutool.core.collection.CollectionUtil;
import com.alibaba.fastjson.JSON;
import com.chuanxia.mcp.bean.model.VideoM3u8;
import com.chuanxia.mcp.bean.vo.UserSystemVideoVo;
import com.chuanxia.mcp.service.VideoM3u8Service;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.springframework.http.ResponseEntity;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;
import org.springframework.web.client.RestTemplate;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;

@Slf4j
@Component
@RequiredArgsConstructor
public class ScheduledService {

    private final M3U8Utils m3U8Utils;
    private final RestTemplate restTemplate;
    private final VideoM3u8Service m3u8Service;

    /**
     * 增量同步
     */
    //@Scheduled(cron = "0/5 * * * * *")
    public void scheduled() {
        Calendar instance = Calendar.getInstance();
        Date startTime = instance.getTime();
        instance.add(5,Calendar.MINUTE);
    }

    public List<VideoM3u8> getM3u8Vo(Date startTime, Date endTime) {
        String url = "";
        ResponseEntity<String> forEntity = restTemplate.getForEntity(url, String.class);
        String body = forEntity.getBody();
        if (StringUtils.isNotBlank(body)) {
            List<UserSystemVideoVo> voList = JSON.parseArray(body, UserSystemVideoVo.class);
            if (CollectionUtil.isNotEmpty(voList)) {
                //解析完成后,统一入库
                List<VideoM3u8> arr = new ArrayList<>();
                for (UserSystemVideoVo userSystemVideoVo : voList) {
                    List<VideoM3u8> videoM3u8s = m3U8Utils.downloadM3U8(userSystemVideoVo.getM3u8Url(), userSystemVideoVo.getVideoId());
                    arr.addAll(videoM3u8s);
                }
                return arr;
            }
        }
        return null;
    }

}